	' !!IMPORTANT!!
	' YOU MUST HAVE WRITE PERMISSIONS TO THE LOCATIONS DEFINED BELOW FOR THE TEMP,DEBUG, AND PRICE FILE
	' YOU MUST UPDATE THE 'strRootFolder' VARIABLE TO POINT TO THE ROOT FOLDER OF YOUR MAGIC ALBUM APPLICATION INSTALL
	' !!IMPORTANT!!
	
	' !!NOTE!!
	' THIS SCRIPT SUPPORTS ARGUMENTS, YOU MAY PASS THE FOLLOWING ARGUMENTS IN TO SET VARIABLES ACCORDINGLY
	' IF ARGUMENT IS NOT PASSED TO SCRIPT, DEFAULTS ARE USED (LISTED BELOW)
	' SETNAME,BLOCKNAME,DEBUGMODE,ROOTFOLDER,VERIFYBEFOREADD,TEMPFILE,DEBUGFILE,PRICEFILE,VERBOSEMODE,FORMAT
	' EXAMPLE:
	' magictraders.vbs pricevalue="average" format="standard" cardfoiling="nonfoil" language="english" setname="ALL" blockname="ALL" debugmode="off" rootfolder="c:\magic album" verifybeforeadd="yes" tempfile="c:\sitetemp.txt" debugfile="c:\sitedebug.txt" pricefile="c:\siteprice.txt" verbosemode="off" 
	' !!NOTE!!
	
	
	Set Args = WScript.Arguments
	Dim strRunTime,strLanguageToCollect,strCardFoilingToCollect,strVerifyBeforeAdd,strBlockNameToCollect,strSetNameToCollect,strFormatToCollect,strUserInput,strStartTime,strEndTime,strDebugMode,ArrPageCount(),ArrSetName(),ArrSetURL(),ArrBlock(),ArrFormat(),ArrStandardFormatSets,ArrExtendedFormatSets,strScriptVersion,strSiteName,strVerboseMode,strRootFolder,strCatalogTempFile,strTempFile,strDebugFile,strPriceFile,strSiteURLHeader,strCatalogURL,strPriceValueToCollect
	ArrStandardFormatSets = Array("Dark Ascension","Innistrad","Magic 2012","New Phyrexia","Mirrodin Besieged","Scars of Mirrodin")
	ArrExtendedFormatSets = Array("Magic 2011","Rise of the Elrazi","Worldwake","Zendikar","Magic 2010","Alara Reborn","Conflux","Shards of Alara")
	strScriptVersion = "2.0"
	strSiteName = "MagicTraders"
	strVerboseMode = "off"	'off,on
	strDebugMode = "off"
	strRootFolder = "..\"
	strCatalogTempFile = strRootFolder & strSiteName & "_catalog.tmp"
	strTempFile = strRootFolder & strSiteName & "_webdata.tmp"
	strDebugFile = strRootFolder & strSiteName & "_debug.tmp"
	strPriceFile = strRootFolder & strSiteName & ".txt"
	strCatalogURL = "http://www.magictraders.com/pricelists/"
	strSiteURLHeader = "http://www.magictraders.com/cgi-bin/set_query.cgi?set="
	strSetNameToCollect = "none"
	strFormatToCollect = "standard"	'standard,extended
	strBlockNameToCollect = "none"
	strVerifyBeforeAdd = "yes"	'yes,no
	strCardFoilingToCollect = "nonfoil"
	strLanguageToCollect = "english"
	strPriceValueToCollect = "average"	'price,average,high,low

	strStartTime = Now()
	DefineGlobalArguments
	If Not LCase(strVerboseMode) = "off" Then
		strUserInput = MsgBox("Verify you have opened the script in a command window otherwise popups between sets will occur and require user interaction." & vbCrLf & vbCrLf & "Do you wish to continue?",36,"Warning - Verbose Mode [" & UCase(strVerboseMode) & "]")
		If strUserInput = 7 Then : WScript.Quit : End If
	End If
	
	If (LCase(strSetNameToCollect) = "all") Or (LCase(strBlockNameToCollect) = "all") Then
		strUserInput = MsgBox("Setting either set name or block name to collect all information can take a substancial amount of time." & vbCrLf & vbCrLf & "Do you wish to continue?",36,"Warning - Set/Blocks to collect set to [ALL]")
		If strUserInput = 7 Then : WScript.Quit : End If
	End If
	If Not Right(strRootFolder,1) = "\" Then : strRootFolder = strRootFolder & "\" : End If
	PreProcesses
	DefineKnownSets
	CollectAvailableSets strCatalogURL,strCatalogTempFile
	DumpArrayInformation
	CollectSetDetails
	PostProcesses
	strEndTime= Now()
	strRunTime = DateDiff("n",strStartTime,strEndTime)
	If Int(strRunTime) < 1 Then : strRunTime = "<1" : End If
	If LCase(strVerboseMode) = "on" Then : WScript.Echo "It took [" & strRunTime & "] minutes to collect all the data" : End If

	Sub DefineGlobalArguments()
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		Dim colArgumentSplit
		For Each Argument in Args
			If InStr(Argument,"=") Then
				'define passed in argument variable information
				If InStr(LCase(Argument),LCase("setname=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strSetNameToCollect = CorrectSetName(colArgumentSplit(1))
					End If
				End If

				If InStr(LCase(Argument),LCase("blockname=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strBlockNameToCollect = colArgumentSplit(1)
					End If
				End If

				If InStr(LCase(Argument),LCase("debugmode=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strDebugMode = colArgumentSplit(1)
					End If
				End If

				If InStr(LCase(Argument),LCase("rootfolder=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strRootFolder = colArgumentSplit(1)
					End If
				End If

				If InStr(LCase(Argument),LCase("verifybeforeadd=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strVerifyBeforeAdd = colArgumentSplit(1)
					End If
				End If

				If InStr(LCase(Argument),LCase("tempfile=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strTempFile = colArgumentSplit(1)
					End If
				End If

				If InStr(LCase(Argument),LCase("debugfile=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strDebugFile = colArgumentSplit(1)
					End If
				End If

				If InStr(LCase(Argument),LCase("pricefile=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strPriceFile = colArgumentSplit(1)
					End If
				End If
				
				If InStr(LCase(Argument),LCase("verbosemode=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strVerboseMode = colArgumentSplit(1)
					End If
				End If
				
				If InStr(LCase(Argument),LCase("language=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strLanguageToCollect = colArgumentSplit(1)
					End If
				End If
				
				If InStr(LCase(Argument),LCase("cardfoiling=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strCardFoilingToCollect = colArgumentSplit(1)
					End If
				End If
				
				If InStr(LCase(Argument),LCase("format=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strFormatToCollect = colArgumentSplit(1)
					End If
				End If
				
				If InStr(LCase(Argument),LCase("pricevalue=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strPriceValueToCollect = colArgumentSplit(1)
					End If
				End If
			Else
				'improperly formated argument passed
			End If
		Next
	End Sub

	Sub DefineKnownSets()
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "Populating predefined product information" : End If
		Dim intNewArraySize
		intNewArraySize = 0
		
		'declare set array information
		Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize) : Redim Preserve ArrBlock(intNewArraySize) : Redim Preserve ArrFormat(intNewArraySize)

		' Example: 
		'	Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize) : Redim Preserve ArrBlock(intNewArraySize) : Redim Preserve ArrFormat(intNewArraySize)
		'	ArrPageCount(intNewArraySize) = 21 : ArrSetName(intNewArraySize) = "Magic 2012" : ArrSetURL(intNewArraySize) = "magic_singles-core_sets-magic_2012/702" : ArrBlock(intNewArraySize) = "Core Sets" : ArrFormat(intNewArraySize) = "Standard" : intNewArraySize = UBound(arrPageCount) + 1
		
		'--core sets
		'--innistrad block
		'--scars of mirrodin block
		'--zendikar block
		'--shares of alara block
		'--shadowmoor block
		'--lorwyn block
		'--time spiral block
		'--ravnica block
		'--kamigawa block
		'--mirrodin block
		'--onslaught block
		'--odyssey block
		'--invasion block
		'--masques block
		'--saga block
		'--tempest block
		'--ice age block
		'--mirage block
		'--stand alone sets
		'--special editions
		'--magic promos
		'--premium deck series
		'--duel decks
		'--from the vault
		
	End Sub

	Function HTTPDownload(myURL, strFile)
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		Dim i, objFile, objFSO, objHTTP, strResults
		strResults = "failed"
		Const ForReading = 1, ForWriting = 2, ForAppending = 8
		Set objFSO = CreateObject( "Scripting.FileSystemObject" )
		Set objFile = objFSO.OpenTextFile( strFile, ForWriting, True )
	    	Set objHTTP = CreateObject( "WinHttp.WinHttpRequest.5.1" )
		objHTTP.Open "GET", myURL, False
		objHTTP.Send
		For i = 1 To LenB( objHTTP.ResponseBody )
			objFile.Write Chr( AscB( MidB( objHTTP.ResponseBody, i, 1 ) ) )
		Next
		objFile.Close( )
		strResults = "success"
		HTTPDownload = strResults
	End Function
	
	Sub WriteLog(strLogFile,strDataToWrite,strRecreate)
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		Dim objFileSys,objFileOpenForAppending
		Set objFileSys = CreateObject("Scripting.FileSystemObject")
		If LCase(strRecreate) = "delete" Then
			If objFileSys.FileExists(strLogFile) Then
				objFileSys.DeleteFile strLogFile,True
			End If
		Else
			If NOT objFileSys.FileExists(strLogFile) Then : objFileSys.CreateTextFile strLogFile : End If
			If (LCase(strRecreate) = "yes") Then : objFileSys.CreateTextFile strLogFile : End If
			Set objFileOpenForAppending = objFileSys.OpenTextFile(strLogFile,8)
			objFileOpenForAppending.WriteLine strDataToWrite
			objFileOpenForAppending.Close
			Set objFileOpenForReading = Nothing
		End If
	End Sub

	Sub DumpArrayInformation()
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		For i = 0 To UBound(ArrSetName)
			WriteLog strDebugFile,"ArrPageCount(" & i & ") = " & """" & ArrPageCount(i) & """" & " : ArrSetName(" & i & ") = " & """" & ArrSetName(i) & """" & " : ArrSetURL(" & i & ") = " & """" & ArrSetURL(i) & """" & " : ArrBlock(" & i & ") = " & """" & ArrBlock(i) & """" & " : ArrFormat(" & i & ") = " & """" & ArrFormat(i) & """","no"
		Next
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "{*}Set information dumped to debug file" : End If
	End Sub

	Function LocateStringInFile(strFile,strStringToLocate)
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		Dim strResults,objFileSys,objFileOpenForReading,strCurrentReadLine
		strResults = "NO"
		Set objFileSys = CreateObject("Scripting.FileSystemObject")
		If objFileSys.FileExists(strFile) Then
			Set objFileOpenForReading = objFileSys.OpenTextFile(strFile,1)
			Do While objFileOpenForReading.AtEndOfStream <> True
				strCurrentReadLine = objFileOpenForReading.ReadLine
				If InStr(LCase(strCurrentReadLine),LCase(strStringToLocate)) Then
					strResults = "YES"
					Exit Do
				End If
			Loop
			objFileOpenForReading.Close
			Set objFileOpenForReading = Nothing
		End If
		Set objFileSys = Nothing
		If strResults = "" Then : strResults = "NO" : End If
		LocateStringInFile = strResults
	End Function

	Sub Folder(strFolderName,strFolderTask)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		Set objFileSys = CreateObject("Scripting.FileSystemObject")
		Select Case LCase(strFolderTask)
			Case "create"
				objFileSys.CreateFolder strFolderName
			Case "recreate"
				If objFileSys.FolderExists(strFolderName) Then : objFileSys.DeleteFolder strFolderName : End If
				objFileSys.CreateFolder strFolderName
			Case "delete"
				If objFileSys.FolderExists(strFolderName) Then : objFileSys.DeleteFolder strFolderName : End If
			Case Else
		End Select
		Set objFileSys = Nothing
	End Sub
	
	Sub File(strFileName,strFileTask)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		Set objFileSys = CreateObject("Scripting.FileSystemObject")
		Select Case LCase(strFileTask)
			Case "create"
				objFileSys.CreateTextFile strFileName
			Case "recreate"
				If objFileSys.FileExists(strFileName) Then : objFileSys.DeleteFile strFileName : End If
				objFileSys.CreateTextFile strFileName
			Case "delete"
				If objFileSys.FileExists(strFileName) Then : objFileSys.DeleteFile strFileName : End If
			Case Else
		End Select
		Set objFileSys = Nothing
	End Sub

	Sub PreProcesses()
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "Performing pre-requirement routine(s)" : End If
		File strCatalogTempFile,"recreate"
		File strTempFile,"recreate"
		File strDebugFile,"recreate"
		File strPriceFile,"recreate"
	End Sub

	Sub PostProcesses()
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "Performing cleanup routine(s)" : End If
		File strCatalogTempFile,"delete"
		File strTempFile,"delete"
		File strDebugFile,"delete"
	End Sub

	Function IdentifySetFormat(strSetToIdentify)
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If	
		Dim strResults
		strResults = "Unknown"

		Select Case LCase(strSetToIdentify)
			Case "unglued"
			Case "unhinged"
			Case Else
				'check if set is in known standard set list
				If InStr(LCase(strResults),"standard") Then
					'do nothing, the set is already marked as in standard format
				Else
					For Each strSet In ArrStandardFormatSets
						If LCase(strSet) = LCase(strSetToIdentify) Then
							If LCase(strResults) = "unknown" Then
								strResults = "Standard"
							Else
								strResults = strResults & ",Standard"
							End If
							Exit For
						End If
					Next
				End If
				
				'check if set is in known extended set list
				If InStr(LCase(strResults),"extended") Then
					'do nothing, the set is already marked as in extended format
				Else
					For Each strSet In ArrStandardFormatSets
						If LCase(strSet) = LCase(strSetToIdentify) Then
							If LCase(strResults) = "unknown" Then
								strResults = "Extended"
							Else
								strResults = strResults & ",Extended"
							End If
							Exit For
						End If
					Next
					
					For Each strSet In ArrExtendedFormatSets
						If LCase(strSet) = LCase(strSetToIdentify) Then
							If LCase(strResults) = "unknown" Then
								strResults = "Extended"
							Else
								strResults = strResults & ",Extended"
							End If
							Exit For
						End If
					Next
				End If 
				
				'apply vintage & legacy
				If LCase(strResults) = "unknown" Then : strResults = "Legacy,Vintage" : Else : strResults = strResults & ",Legacy,Vintage" : End If
		
		End Select
				
		'return results
		IdentifySetFormat = strResults
		
	End Function

'routines that should be different based on site

	Function IdentifyBlockInformation(strSetName)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		Dim strResults
		strResults = ""		
		'there is no way to determin block information from site, manual entry would be required
		IdentifyBlockInformation = strResults
	End Function	

	Function IdentifyCardVersion(strCardName,strCardSet)
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		Dim strResults
		Select Case LCase(strCardName)
			Case Else
		End Select
		If strResults = "" Then : strResults = "*" : End If
		IdentifyCardVersion = strResults
	End Function

	Function IdentifySetPageCount(strSetName,strSetURL)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		Dim strResults,objFileSys,objFileOpenForReading,strCurrentReadLine
		strResults = 1	'there is only 1 page per set on magictraders.com
		IdentifySetPageCount = strResults
	End Function

	Function CorrectSetName(strSetNameToCorrect)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		Dim strResults
		Select Case strSetNameToCorrect
			Case Else
		End Select
		If strResults = "" Then : strResults = strSetNameToCorrect : End If
		CorrectSetName = strResults
	End Function
	
	Function CorrectCardName(strCardNameToCorrect)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		Dim strResults,colCardNameSplitOne
		Select Case strCardNameToCorrect
			Case "Villagers of Estwald" : strResults = "Villagers of Estwald|Howlpack of Estwald"
			Case "Village Ironsmith" : strResults = "Village Ironsmith|Ironfang"
			Case "Ulvenwald Mystics" : strResults = "Ulvenwald Mystics|Ulvenwald Primordials"
			Case "Tormented Pariah" : strResults = "Tormented Pariah|Rampaging Werewolf"
			Case "Thraben Sentry" : strResults = "Thraben Sentry|Thraben Militia"
			Case "Screeching Bat" : strResults = "Screeching Bat|Stalking Vampire"
			Case "Reckless Waif" : strResults = "Reckless Waif|Merciless Predator"
			Case "Mayor of Avabruck" : strResults = "Mayor of Avabruck|Howlpack Alpha"
			Case "Ludevic's Test Subject" : strResults = "Ludevics Test Subject|Ludevics Abomination"
			Case "Kruin Outlaw" : strResults = "Kruin Outlaw|Terror of Kruin Pass"
			Case "Instigator Gang" : strResults = "Instigator Gang|Wildblood Pack"
			Case "Hanweir Watchkeep" : strResults = "Hanweir Watchkeep|Bane of Hanweir"
			Case "Grizzled Outcasts" : strResults = "Grizzled Outcasts|Krallenhorde Wantons"
			Case "Gatstaf Shepherd" : strResults = "Gatstaf Shepherd|Gatstaf Howler"
			Case "Garruk Relentless" : strResults = "Garruk Relentless|Garruk, the Veil-Cursed"
			Case "Delver of Secrets" : strResults = "Delver of Secrets|Insectile Aberration"
			Case "Daybreak Ranger" : strResults = "Daybreak Ranger|Nightfall Predator"
			Case "Cloistered Youth" : strResults = "Cloistered Youth|Unholy Fiend"
			Case "Civilized Scholar" : strResults = "Civilized Scholar|Homicidal Brute"
			Case "Bloodline Keeper" : strResults = "Bloodline Keeper|Lord of Lineage"
			Case Else
				If InStr(strCardNameToCorrect,"(") Then
					colCardNameSplitOne = Split(strCardNameToCorrect,"(")
					strResults = Trim(colCardNameSplitOne(LBound(colCardNameSplitOne)))
				End If
		End Select
		If strResults = "" Then : strResults = strCardNameToCorrect : End If
		CorrectCardName = strResults
	End Function
	
	Sub CollectAvailableSets(strWebSiteURL,strSaveFile)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "Identifying site product information" : End If
		Dim strShouldWeCollectThisSet,strResults,strCurrentReadLine,strOpenBlock,strCloseBlock,strOpenBlockFound,strBlock,colBlockSplit,strSetLine,colSetLineSplitOne,colSetLineSplitTwo,strIdentifiedSetName,strIdentifiedSetURL,strIdentifiedSetFormat,strIdentifiedSetBlock,strIdentifiedSetPageCount,intNewArraySize
		
		strSetLine = "option value"
		strOpenBlock = "Magic prices by set:"
		strCloseBlock = "</SELECT>"
		strOpenBlockFound = "no"
		strBlock = ""
		strIdentifiedSetName = ""
		strIdentifiedSetURL = ""
		strIdentifiedSetFormat = ""
		strShouldWeCollectThisSet = "no"
		
		'download available site sets
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "{*}Downloading product catalog information" : End If
		strResults = HTTPDownload(strWebSiteURL,strSaveFile)
		If LCase(strResults) = "success" Then
			Set objFileSys = CreateObject("Scripting.FileSystemObject")
			If objFileSys.FileExists(strSaveFile) Then
				Set objFileOpenForReading = objFileSys.OpenTextFile(strSaveFile,1)
				Do While objFileOpenForReading.AtEndOfStream <> True
					strCurrentReadLine = objFileOpenForReading.ReadLine
					If InStr(LCase(strCurrentReadLine),LCase(strOpenBlock)) Then : strOpenBlockFound = "yes" : End If
					If LCase(strOpenBlockFound) = "yes" Then
						If strBlock = "" Then : strBlock = strCurrentReadLine : Else : strBlock = strBlock & vbCrLf & strCurrentReadLine : End If
						If InStr(LCase(strCurrentReadLine),LCase(strCloseBlock)) Then : Exit Do : End If
					End If
				Loop
				objFileOpenForReading.Close
				Set objFileOpenForReading = Nothing
			End If
		End If
		
		'determin available site sets
		colBlockSplit = Split(strBlock,vbCrLf)
		For Each Line In colBlockSplit
			If InStr(LCase(Line),LCase(strSetLine)) Then
				strShouldWeCollectThisSet = "no"
				
				'identify set name
				colSetLineSplitOne = Split(Line,">")
				strIdentifiedSetName = Trim(colSetLineSplitOne(UBound(colSetLineSplitOne)))
				strIdentifiedSetName = CorrectSetName(strIdentifiedSetName)
				
				'identify set url
				colSetLineSplitTwo = Split(colSetLineSplitOne(LBound(colSetLineSplitOne)),"""")
				strIdentifiedSetURL = strSiteURLHeader & Trim(colSetLineSplitTwo(1)) & "&excel=true"
				
				'identify set format
				strIdentifiedSetFormat = IdentifySetFormat(strIdentifiedSetName)
				
				'idnetify set block
				strIdentifiedSetBlock = IdentifyBlockInformation(strIdentifiedSetName)
				
				'determin if we are interested in this set
				If LCase(strSetNameToCollect) = "all" Then
					strShouldWeCollectThisSet = "yes"
				Else
					If LCase(strIdentifiedSetName) = LCase(strSetNameToCollect) Then
						strShouldWeCollectThisSet = "yes"
					Else
						If LCase(strBlockNameToCollect) = "all" Then
							strShouldWeCollectThisSet = "yes"
						Else
							If LCase(strIdentifiedSetBlock) = LCase(strBlockNameToCollect) Then
								strShouldWeCollectThisSet = "yes"
							Else
								If InStr(LCase(strIdentifiedSetFormat),LCase(strFormatToCollect)) Then
									strShouldWeCollectThisSet = "yes"
								End If
							End If
						End If
					End If
				End If
				
				'add set information to array if we are interested in the set
				If LCase(strShouldWeCollectThisSet) = "yes" Then
					strIdentifiedSetPageCount = IdentifySetPageCount(strIdentifiedSetName,strIdentifiedSetURL)
					intNewArraySize = UBound(ArrSetName) + 1
					Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize) : Redim Preserve ArrBlock(intNewArraySize) : Redim Preserve ArrFormat(intNewArraySize)
					ArrPageCount(intNewArraySize) = strIdentifiedSetPageCount : ArrSetName(intNewArraySize) = strIdentifiedSetName : ArrSetURL(intNewArraySize) = strIdentifiedSetURL : ArrBlock(intNewArraySize) = strIdentifiedSetBlock : ArrFormat(intNewArraySize) = strIdentifiedSetFormat
					If LCase(strVerboseMode) = "on" Then : WScript.Echo "-->Identified [" & strIdentifiedSetName & "] set" : End If
				End If
			End If
		Next
	End Sub

	Sub CollectSetDetails()
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "Identifying detailed set information" : End If
		Dim strResults,strCurrentReadLine,strCardLineDelimiter,colCurrentLineSplitOne,colCurrentLineSplitTwo,strIdentifiedCardName,strIdentifiedCardPrice,strIdentifiedCardVersion
		strCardLineDelimiter = "|"
		
		For i = 0 To UBound(ArrSetName)
			If Not ArrSetName(i) = "" Then
				'download set details
				If LCase(strVerboseMode) = "on" Then : WScript.Echo "{*}Downloading [" & ArrSetName(i) & "] details on (" & Now() & ")" : End If
				strResults = HTTPDownload(ArrSetURL(i),strTempFile)
				If LCase(strResults) = "success" Then
					Set objFileSys = CreateObject("Scripting.FileSystemObject")
					If objFileSys.FileExists(strTempFile) Then
						Set objFileOpenForReading = objFileSys.OpenTextFile(strTempFile,1)
						Do While objFileOpenForReading.AtEndOfStream <> True
							strIdentifiedCardName
							strCurrentReadLine = objFileOpenForReading.ReadLine
							If InStr(strCurrentReadLine,strCardLineDelimiter) Then
								If InStr(LCase(strCurrentReadLine),"stddev") Then
									'skip the line, its a header line
								Else
									colCurrentLineSplitOne = Split(strCurrentReadLine,strCardLineDelimiter)
									If UBound(colCurrentLineSplitOne) = 7 Then
										'identify card name
										strIdentifiedCardName = colCurrentLineSplitOne(LBound(colCurrentLineSplitOne))
										strIdentifiedCardName = CorrectCardName(strIdentifiedCardName)
										
										'identify card value (default to price)
										Select Case LCase(strPriceValueToCollect)
											Case "average" : strIdentifiedCardPrice = colCurrentLineSplitOne(3)
											Case "high" : strIdentifiedCardPrice = colCurrentLineSplitOne(4)
											Case "low" : strIdentifiedCardPrice = colCurrentLineSplitOne(5)
											Case "price" : strIdentifiedCardPrice = colCurrentLineSplitOne(1)
											Case Else : strIdentifiedCardPrice = colCurrentLineSplitOne(3)
										End Select
										
										'identify card version
										strIdentifiedCardVersion = IdentifyCardVersion(strIdentifiedCardName,ArrSetName(i))
										
										'write located card value to price file
										WriteLog strPriceFile,strIdentifiedCardName & vbTab & strIdentifiedCardPrice & vbTab & ArrSetName(i) & vbTab & LCase(strLanguageToCollect) & vbTab & strIdentifiedCardVersion & vbTab & LCase(strCardFoilingToCollect),"no"
									End If
								End If
							End If
						Loop
						objFileOpenForReading.Close
						Set objFileOpenForReading = Nothing
					End If
					Set objFileSys = Nothing
				End If
			End If
		Next
		
	End Sub
	